# AUTOGENERATED! DO NOT EDIT! File to edit: compress.ipynb (unless otherwise specified).

__all__ = ['compressDict', 'decompressDict']

# Cell
import gzip, zlib, base64, pickle
from typing import Callable, Optional
from beartype import beartype

# Cell
@beartype
def compressDict(data:dict,encoder:Callable= pickle.dumps,
                 compressor:Callable=zlib.compress,
                 stringifier:Callable = base64.b64encode)->bytes:
  compressedData =  compressor(encoder(data))
  return stringifier(compressedData)

# Cell
@beartype
def decompressDict( data:(bytes,str),
                   decoder = pickle.loads,
                   decompressor:Callable= zlib.decompress,
                   destringifier:Callable = base64.b64decode)->dict:
  compressedData = destringifier(data)
  return decoder(decompressor(compressedData))